Index: trunk/LMDZ.TITAN/libf/phytitan/write_histday.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/write_histday.h	(revision 1055)
+++ trunk/LMDZ.TITAN/libf/phytitan/write_histday.h	(revision 1056)
@@ -3,120 +3,72 @@
 !
       IF (ok_journe) THEN
-c
-      ndex2d = 0
-      ndex3d = 0
-      zx_tmp_2d = 0.
-      zx_tmp_3d = 0.
-      zx_tmp_fi2d=0.
-      zx_tmp_fi3d=0.
-c
+
          zsto = dtime
-         zout = dtime * FLOAT(ecrit_day)
+         zout = dtime * REAL(ecrit_day)
          itau_w = itau_phy + itap
 
-c
 c-------------------------------------------------------
       IF(lev_histday.GE.1) THEN
-c
+
 ccccccccccccc 2D fields, invariables
-c
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,pphis,zx_tmp_2d)
-      CALL histwrite(nid_day,"phis",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-C
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,airephy,zx_tmp_2d)
-      CALL histwrite(nid_day,"aire",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_day,.false.,"phis",itau_w,pphis)
+      call histwrite_phy(nid_day,.false.,"aire",itau_w,airephy)
+
 ccccccc axe Ls ... Faudrait le reduire a axe temporel seulement...
-      do j=1,jjmp1
-       do i=1,iim
-        zx_tmp_2d(i,j)=zls*180./RPI      ! zls est en radians !!
-       enddo
-      enddo
-c Correction passage de 360 à 0... Sinon probleme avec moyenne
+c Correction passage de 360 a 0... Sinon probleme avec moyenne
       if (zls.lt.zlsm1) then
-        zx_tmp_2d = zx_tmp_2d+360.
+        do i=1,klon
+          tmpout(i,1) = zls*180./RPI+360.
+        enddo
         zlsm1 = 2.*RPI
       else
+        do i=1,klon
+          tmpout(i,1) = zls*180./RPI
+        enddo
         zlsm1 = zls
       endif
-      CALL histwrite(nid_day,"ls",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+      call histwrite_phy(nid_day,.false.,"ls",itau_w,tmpout(:,1))
+
 ccccccccccccc 2D fields, variables
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, ftsol,zx_tmp_2d)
-      CALL histwrite(nid_day,"tsol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      DO i = 1, klon
-         zx_tmp_fi2d(i) = paprs(i,1)
-      ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"psol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, ue,zx_tmp_2d)
-c     CALL histwrite(nid_day,"ue",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, ve,zx_tmp_2d)
-c     CALL histwrite(nid_day,"ve",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_day,.false.,"tsol",itau_w,ftsol)
+      call histwrite_phy(nid_day,.false.,"psol",itau_w,paprs(:,1))
+
+c     call histwrite_phy(nid_day,.false.,"ue",itau_w,ue)
+c     call histwrite_phy(nid_day,.false.,"ve",itau_w,ve)
+
       ENDIF !lev_histday.GE.1
-c
+
 c-------------------------------------------------------
       IF(lev_histday.GE.2) THEN
-c
+
 ccccccccccccc 3D fields, basics
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, t_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"temp",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, pplay, zx_tmp_3d)
-      CALL histwrite(nid_day,"pres",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, zphi, zx_tmp_3d)
-      CALL histwrite(nid_day,"geop",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, u_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitu",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, v_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitv",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, omega, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitw",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, topsw,zx_tmp_2d)
-      CALL histwrite(nid_day,"tops",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_dyn, zx_tmp_3d)
-      CALL histwrite(nid_day,"dudyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_vdf, zx_tmp_3d)
-      CALL histwrite(nid_day,"duvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+
+      call histwrite_phy(nid_day,.false.,"temp",itau_w,t_seri)
+      call histwrite_phy(nid_day,.false.,"pres",itau_w,pplay)
+      call histwrite_phy(nid_day,.false.,"geop",itau_w,zphi)
+      call histwrite_phy(nid_day,.false.,"vitu",itau_w,u_seri)
+      call histwrite_phy(nid_day,.false.,"vitv",itau_w,v_seri)
+      call histwrite_phy(nid_day,.false.,"vitw",itau_w,omega)
+      call histwrite_phy(nid_day,.false.,"tops",itau_w,topsw)
+      call histwrite_phy(nid_day,.false.,"duvdf",itau_w,d_u_vdf)
+      call histwrite_phy(nid_day,.false.,"dudyn",itau_w,d_u_dyn)
+
 cccccccccccccccccc  Tracers
-c
+
          if (iflag_trac.eq.1) THEN
           if (microfi.ge.1) then
-c           DO iq=1,nmicro
-c      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, qaer(1,1,iq), zx_tmp_3d)
-c      CALL histwrite(nid_day,tname(iq),itau_w,zx_tmp_3d,
-c     .                                   iim*jjmp1*klev,ndex3d)
-c           ENDDO
+c          DO iq=1,nmicro
+c      call histwrite_phy(nid_day,.false.,tname(iq),
+c    .                    itau_w,qaer(1:klon,1:klev,iq))
+c          ENDDO
 c    -------   NB AER TOT
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,1:nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_day,"qaer",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,1:nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_day,.false.,"qaer",itau_w,tmpout)
 
              if (clouds.eq.1) then
@@ -124,140 +76,116 @@
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,nrad+1:2*nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_day,"qnoy",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,nrad+1:2*nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_day,.false.,"qnoy",itau_w,tmpout)
 c    -------   V GLA1 TOT
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,2*nrad+1:3*nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_day,"qgl1",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,2*nrad+1:3*nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_day,.false.,"qgl1",itau_w,tmpout)
 c    -------   V GLA2 TOT
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,3*nrad+1:4*nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_day,"qgl2",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,3*nrad+1:4*nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_day,.false.,"qgl2",itau_w,tmpout)
 c    -------   V GLA3 TOT
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,4*nrad+1:5*nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_day,"qgl3",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,4*nrad+1:5*nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_day,.false.,"qgl3",itau_w,tmpout)
 c --------------
 c ----- SATURATION ESP NUAGES
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satch4,zx_tmp_3d)
-       CALL histwrite(nid_day,"ch4sat", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satc2h6,zx_tmp_3d)
-       CALL histwrite(nid_day,"c2h6sat", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satc2h2,zx_tmp_3d)
-       CALL histwrite(nid_day,"c2h2sat", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_day,.false.,"ch4sat",itau_w,satch4)
+       call histwrite_phy(nid_day,.false.,"c2h6sat",itau_w,satc2h6)
+       call histwrite_phy(nid_day,.false.,"c2h2sat",itau_w,satc2h2)
 c --------------
 c ----- RESERVOIR DE SURFACE
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,reservoir,zx_tmp_2d)
-       CALL histwrite(nid_day,"reserv",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_day,.false.,"reserv",itau_w,reservoir)
 c --------------
 c ----- ECHANGE GAZ SURF/ATM (evaporation)
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,evapch4,zx_tmp_2d)
-       CALL histwrite(nid_day,"evapch4",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_day,.false.,"evapch4",itau_w,evapch4)
 c --------------
 c ----- PRECIPITATIONS
 c       -----  CH4
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,precip(1:klon,1),zx_tmp_2d)
-       CALL histwrite(nid_day,"prech4",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_day,.false.,"prech4",
+     .            itau_w,precip(1:klon,1))
 c       -----  C2H6
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,precip(1:klon,2),zx_tmp_2d)
-       CALL histwrite(nid_day,"prec2h6",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_day,.false.,"prec2h6",
+     .            itau_w,precip(1:klon,2))
 c       -----  C2H2
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,precip(1:klon,3),zx_tmp_2d)
-       CALL histwrite(nid_day,"prec2h2",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
-c
+       call histwrite_phy(nid_day,.false.,"prec2h2",
+     .            itau_w,precip(1:klon,3))
+c       -----  NOY
+       call histwrite_phy(nid_day,.false.,"prenoy",
+     .            itau_w,precip(1:klon,4))
+c       -----  AER
+       call histwrite_phy(nid_day,.false.,"preaer",
+     .            itau_w,precip(1:klon,5))
 c --------------
 c ----- FLUX GLACE
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .              flxesp_i(1:klon,1:klev,1),zx_tmp_3d)
-       CALL histwrite(nid_day,"flxgl1", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .              flxesp_i(1:klon,1:klev,2),zx_tmp_3d)
-       CALL histwrite(nid_day,"flxgl2", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .              flxesp_i(1:klon,1:klev,3),zx_tmp_3d)
-       CALL histwrite(nid_day,"flxgl3", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+c       -----  CH4
+       call histwrite_phy(nid_day,.false.,"flxgl1",
+     .            itau_w,flxesp_i(1:klon,1:klev,1))
+c       -----  C2H6
+       call histwrite_phy(nid_day,.false.,"flxgl2",
+     .            itau_w,flxesp_i(1:klon,1:klev,2))
+c       -----  C2H2
+       call histwrite_phy(nid_day,.false.,"flxgl3",
+     .            itau_w,flxesp_i(1:klon,1:klev,3))
+c --------------
+c ----- Source/puits GLACE
+c       -----  CH4
+       call histwrite_phy(nid_day,.false.,"solch4",
+     .            itau_w,solesp(1:klon,1:klev,1))
+c       -----  C2H6
+       call histwrite_phy(nid_day,.false.,"solc2h6",
+     .            itau_w,solesp(1:klon,1:klev,2))
+c       -----  C2H2
+       call histwrite_phy(nid_day,.false.,"solc2h2",
+     .            itau_w,solesp(1:klon,1:klev,3))
 c --------------
 c ----- RAYON MOYEN GOUTTE
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, rmcloud,zx_tmp_3d)
-       CALL histwrite(nid_day,"rcldbar", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+       call histwrite_phy(nid_day,.false.,"rcldbar",itau_w,rmcloud)
+
              endif
 	  endif
-c
+
 c --------------
 c ----- TRACEURS CHIMIQUES
 	  if (nmicro.lt.nqmax) then
            DO iq=nmicro+1,nqmax
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,tr_seri(1,1,iq),zx_tmp_3d)
-       CALL histwrite(nid_day,tname(iq),itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_day,.false.,tname(iq),
+     .                    itau_w,tr_seri(1:klon,1:klev,iq))
            ENDDO
 	  endif
          endif
-c
+
       ENDIF !lev_histday.GE.2
-c
+
 c-------------------------------------------------------
       IF(lev_histday.GE.3) THEN
-c
+
 cccccccccccccccccc  Radiative transfer
-c
+
 c 2D
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, toplw,zx_tmp_2d)
-      CALL histwrite(nid_day,"topl",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, solsw,zx_tmp_2d)
-      CALL histwrite(nid_day,"sols",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollw,zx_tmp_2d)
-      CALL histwrite(nid_day,"soll",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_day,.false.,"topl",itau_w,toplw)
+      call histwrite_phy(nid_day,.false.,"sols",itau_w,solsw)
+      call histwrite_phy(nid_day,.false.,"soll",itau_w,sollw)
+
 c 3D
-c
-      zx_tmp_fi3d(1:klon,1:klev)=swnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"SWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=lwnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"LWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+
+      call histwrite_phy(nid_day,.false.,"SWnet",
+     .          itau_w,swnet(1:klon,1:klev))
+      call histwrite_phy(nid_day,.false.,"LWnet",
+     .          itau_w,lwnet(1:klon,1:klev))
+
 c --------------
 c ----- OPACITE BRUME
@@ -268,9 +196,6 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"thv"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_day,.false.,"thv"//str2,itau_w,t_tauhvd)
        enddo      ! fin boucle NSPECV 
 
@@ -281,11 +206,7 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"thi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_day,.false.,"thi"//str2,itau_w,t_tauhvd)
        enddo      ! fin boucle NSPECI 
-c
 c --------------
 c ----- EXTINCTION BRUME
@@ -302,9 +223,6 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"khv"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_day,.false.,"khv"//str2,itau_w,t_khvd)
        enddo      ! fin boucle NSPECV 
 
@@ -321,11 +239,7 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"khi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_day,.false.,"khi"//str2,itau_w,t_khvd)
        enddo      ! fin boucle NSPECI 
-c
 c --------------
 c ----- OPACITE GAZ
@@ -336,9 +250,6 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"tgv"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_day,.false.,"tgv"//str2,itau_w,t_tauhvd)
        enddo      ! fin boucle NSPECV 
 
@@ -349,11 +260,7 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"tgi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_day,.false.,"tgi"//str2,itau_w,t_tauhvd)
        enddo      ! fin boucle NSPECI 
-c
 c --------------
 c ----- EXTINCTION GAZ
@@ -370,9 +277,6 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"kgv"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_day,.false.,"kgv"//str2,itau_w,t_khvd)
        enddo      ! fin boucle NSPECV 
 
@@ -390,18 +294,13 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"kgi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_day,.false.,"kgi"//str2,itau_w,t_khvd)
        enddo      ! fin boucle NSPECI 
 
 c --------------
+         if (clouds.eq.1) then
+c --------------
 c ----- OPACITE NUAGES (ATTENTION PROXY)
-         if (clouds.eq.1) then
-           zx_tmp_fi3d(1:klon,1:klev)=occcld(1:klon,1:klev)
-           CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-           CALL histwrite(nid_day,"tcld",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         call histwrite_phy(nid_day,.false.,"tcld",itau_w,occcld)
 c --------------
 c ----- EXTINCTION NUAGES (ATTENTION PROXY)
@@ -414,74 +313,40 @@
              enddo
            enddo
-           zx_tmp_fi3d(1:klon,1:klev)=t_kcld(1:klon,1:klev)
-           CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-           CALL histwrite(nid_day,"kcld",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         call histwrite_phy(nid_day,.false.,"kcld",itau_w,t_kcld)
+c --------------
         endif  
-c
+c --------------
+
       ENDIF !lev_histday.GE.3
-c
+
 c-------------------------------------------------------
       IF(lev_histday.GE.4) THEN
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t_dyn, zx_tmp_3d)
-      CALL histwrite(nid_day,"dtdyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t, zx_tmp_3d)
-      CALL histwrite(nid_day,"dtphy",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+
+      call histwrite_phy(nid_day,.false.,"dtdyn",itau_w,d_t_dyn)
+      call histwrite_phy(nid_day,.false.,"dtphy",itau_w,d_t)
 c K/s
-      zx_tmp_fi3d(1:klon,1:klev)=d_t_vdf(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"dtvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dtvdf",itau_w,d_t_vdf)
 c K/s
-      zx_tmp_fi3d(1:klon,1:klev)=d_t_ajs(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"dtajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dtajs",itau_w,d_t_ajs)
 c K/s
-      zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"dtswr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dtswr",itau_w,heat)
+c K/s
+      call histwrite_phy(nid_day,.false.,"dtlwr",itau_w,-1.*cool)
 c K/s      
-      zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"dtlwr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c K/s      
-c     zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-c     CALL histwrite(nid_day,"dtec",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c      call histwrite_phy(nid_day,.false.,"dtec",itau_w,d_t_ec)
+
       ENDIF !lev_histday.GE.4
-c
+
 c-------------------------------------------------------
       IF(lev_histday.GE.5) THEN
-c
-c
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxu , zx_tmp_2d)
-c      CALL histwrite(nid_day,"taux_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d) 
-c      
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxv , zx_tmp_2d)
-c      CALL histwrite(nid_day,"tauy_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragm,zx_tmp_2d)
-c     CALL histwrite(nid_day,"cdrm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragh,zx_tmp_2d)
-c     CALL histwrite(nid_day,"cdrh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+c      call histwrite_phy(nid_day,.false.,"taux",itau_w,fluxu)
+c      call histwrite_phy(nid_day,.false.,"tauy",itau_w,fluxv)
+c      call histwrite_phy(nid_day,.false.,"cdrm",itau_w,cdragm)
+c      call histwrite_phy(nid_day,.false.,"cdrh",itau_w,cdragh)
+
       ENDIF !lev_histday.GE.5
 c-------------------------------------------------------
-c
+
       if (ok_sync) then
         call histsync(nid_day)
